import os,os.path,string,commands
import re
import cherrypy
from cherrypy.lib import static

class IOV(object):
    def __init__(self,authpath):
        self.__authdir=authpath
        self.__datasavedir=os.path.dirname(os.path.abspath(__file__))
    @cherrypy.expose
    def index(self):
        return "IOVPAGE!!!"
    
    @cherrypy.expose
    def getTags(self,service,schema,viacache):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(service) != None) or (p.match(schema) != None) :
            return "internal error - unauthourized access"
        cmd=['cmscond_list_iov','-a','-c']
        cmdstr=''
        oracle_str='oracle://'+service+'/'+schema
        frontier_str='frontier://cmsfrontier.cern.ch:8000'+'/'+service+'/'+schema
        if len(viacache)==0:
            cmd.append(oracle_str)
            cmd.append('-P')
            cmd.append(self.__authdir)
        else:
            cmd.append(frontier_str)
        cmdstr=' '.join(cmd)
        cmdout = commands.getoutput(cmdstr)
        results = string.split(cmdout,'\n')
        result=''
        for entry in results:
            result += entry.strip() +';'
        return result
        
    @cherrypy.expose
    def getIOVForTag(self,service,schema,tag,viacache):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(service) != None) or (p.match(schema) != None) or (p.match(tag)!= None):
            return "internal error - unauthourized access"
        cmd=['cmscond_list_iov','-t',tag,'-c']
        oracle_str='oracle://'+service+'/'+schema
        frontier_str='frontier://cmsfrontier.cern.ch:8000'+'/'+service+'/'+schema
        if len(viacache)==0:
            cmd.append(oracle_str)
            cmd.append('-P')
            cmd.append(self.__authdir)
        else:
            cmd.append(frontier_str)
        cmdstr=' '.join(cmd)
        cmdout = commands.getoutput(cmdstr)
        results = string.split(cmdout,'\n')
        result=''
        for entry in results:
            result += entry.strip() +';'
        return result
    
    @cherrypy.expose
    def getFile(self,service,schema,tag,viacache,payload,filename):
        datafile=os.path.join(self.__datasavedir,filename)
        destconnect='sqlite_file://'+datafile
        oracle_str='oracle://'+service+'/'+schema
        frontier_str='frontier://cmsfrontier.cern.ch:8000'+'/'+service+'/'+schema
        sourceconnect=''
        if len(viacache)==0:
            sourceconnect=oracle_str
        else:
            sourceconnect=frontier_str
        fields=schema.split('_')
        det=fields[len(fields)-1]
        cmdstr = 'cmscond_list_dictionary'
        cmdout = commands.getoutput(cmdstr)
        dicts=string.split(cmdout,'\n')
        dict='CondFormatsCalibration' #default dictionary
        for d in dicts:
            if string.lower(d).find(string.lower(det)) != -1:
                dict = d.strip()
        cmd = ['cmscond_export_iov','-s',sourceconnect,'-d',destconnect,'-D',dict,'-n',payload,'-p',self.__authdir,'-t',tag]
        cmdstr=' '.join(cmd)
        #print cmd
        cmdout = commands.getoutput(cmdstr)
        #print cmdout
        #print os.path.basename(datafile)
        return static.serve_file(datafile, "application/x-download", "attachment",os.path.basename(datafile))
    
if __name__ == '__main__':
    currentdir=os.path.dirname(os.path.abspath(__file__))
    authdir=os.path.join(currentdir,'..','auth')
    iov=IOV(authdir)
    r1=iov.getTags('cms_orcoff','CMS_COND_CSC','')
    if len(r1) != 0:
        tag=r1.split(';')[0]
        print iov.getIOVForTag('cms_orcoff','CMS_COND_CSC',tag,'')
    r2=iov.getTags('FrontierDev','CMS_COND_CSC','CHECKED')
    print r2
    if len(r2) != 0:
        tag=r2.split(';')[0]
        print iov.getIOVForTag('FrontierDev','CMS_COND_CSC',tag,'CHECKED')
    
