import os
import re
from string import lower, find
import cherrypy
from cherrypy.lib.cptools import serveFile
import md5
import urllib

    
class Tag:

    home = "/home/cmscond"
    cmsenv = "source "+home+"/cmsset_default.sh"
    dir = home+"/slc3_ia32_gcc323/cms/cmssw/CMSSW_1_4_2"
    dict_dir= "/home/cmscond/slc3_ia32_gcc323/cms/cmssw/CMSSW_1_4_2/CondCore/Utilities/scripts"
    tns = "export TNS_ADMIN=" + home
    data_dir = home + "/data"
    
    def getTags(self, service, detector, password, viaCache, map):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(service) != None) or (p.match(detector) != None) or (p.match(password)!= None):
            return "internal error - unauthourized access"        
        if (viaCache!="true"):
            cmd = "cmscond_list_iov -c oracle://" +  service +"/CMS_COND_"+detector+' -u cms_cond_general_r -p '+ password +' -a;'
        else:
            cmd = "cmscond_list_iov -c frontier://cmsfrontier.cern.ch:8000/"+map+"/CMS_COND_"+detector +' -a;'
        setenv = self.cmsenv+";cd "+self.dir+"; eval `scramv1 runtime -sh`; "+self.tns+"; "+cmd
        con = os.popen(setenv)
        list = con.readlines()  
        result =''
        for entry in list:
            result += entry.strip() +';'
        return result
        
        
    getTags.exposed = True
    
    def getIOVForTag(self, service, detector, password, tag, viaCache, map):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(service) != None) or (p.match(detector) != None) or (p.match(password) != None) or (p.match(tag)!= None):
            return "internal error - unauthourized access"
        rel_catalog = "relationalcatalog_oracle://"+service+"/cms_cond_general"
        if (viaCache!="true"):
            cmd = "cmscond_list_iov -c oracle://" +  service +"/CMS_COND_"+detector+' -u cms_cond_general_r -p '+ password +' -t '+tag+' -f '+rel_catalog
        else:
            cmd = "cmscond_list_iov -c frontier://cmsfrontier.cern.ch:8000/"+map+"/CMS_COND_"+detector+' -u cms_cond_general_r -p '+ password + ' -t '+tag+' -f '+rel_catalog
        setenv = self.cmsenv+";cd  "+self.dir+"; eval `scramv1 runtime -sh`; "+self.tns+"; "+cmd
        con = os.popen(setenv)
        list = con.readlines()  
        result =''
        for entry in list:
            result += entry.strip() +';'
        
        return result
         
    getIOVForTag.exposed = True
 
    def getFile(self, service,detector, tag, map, payload,file_name):
        download_cat = self.home+ '/test/'
        input_cat = self.dir + "/src/CondCore/DBCommon/data/"
        input_file = "file:"+input_cat
        if service=="cms_orcoff":
            input_file += "offlineCondDBCatalog.xml"
        elif service=="orcon":
            input_file+="onlineCondDBCatalog.xml"
        elif service=="cms_orcoff_int2r":
            input_file+="devCondDBCatalog.xml"
        else:           #devdb10
            input_file = "relationalcatalog_oracle://devdb10/CMS_COND_GENERAL"
        
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(service) != None) or (p.match(detector) != None) or (p.match(map) != None) or (p.match(tag)!= None)\
               or (p.match(payload)!= None) or (p.match(file_name)!= None):
            return "internal error - unauthourized access"
        cmd = "cd "+self.dict_dir + ";./cmscond_list_dictionary"
        con = os.popen(cmd)
        dictionaries = con.readlines()
        for el in dictionaries:
            if lower(el).find(lower(detector)) != -1:
                dict = el.strip()         
        cmd = "cmscond_export_iov -s oracle://"+ service +"/CMS_COND_"+detector+" -d sqlite_file:"+download_cat+file_name+".db -D "+dict+" -i "+input_file+\
        " -o file:"+download_cat+file_name+".xml -t "+tag+" -n "+payload+" -p "+self.home+ " --withBlob"
        #print cmd
        con = os.popen(self.cmsenv+"; cd "+self.dir+"; eval `scramv1 runtime -sh`; "+cmd)
        error = con.readlines()
        #print 'ERROR'
        #print error
        if len(error)>0:
            msg=''
            for el in error:
                msg+=el
            return "Cmd-line error "+msg
        
        return serveFile(download_cat+file_name+'.db', "application/x-download", "attachment")
        #return serveFile('/home/cmscond/test/blabla.db', "application/x-download", "attachment") 
    getFile.exposed = True

    def remFile(self, filename, filesum):
        #print "REM FILE"
        #print filename
        #print filesum
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(filename) != None) or (p.match(filesum) != None):
            return "internal error - unauthourized access"
        m = md5.new()
        m.update(filename)
        dig = m.hexdigest()
        #print dig
        if (dig== filesum):
            #print 'OK'
            try:
                os.popen("cd /home/cmscond/test; rm "+filename+'.db; rm '+filename+".xml;")
            except:
                return "false"
            return "true"
        else:
            return "Unauthorized access"

    remFile.exposed = True    

    def listFiles(self, dir_name):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(dir_name) != None):
            return "internal error - unauthourized access"
        cmd = "cd "+self.data_dir+"/"+dir_name+"; ls"
        con = os.popen(cmd)
        res = con.readlines()
        result =''
        for entry in res:
            result += entry.strip() +';'
       # print res
        return result
    

    listFiles.exposed= True
    
    def getSqliteFile(self, dir, file_name):
        p = re.compile('\w*[\a\n\n\v\t\r();:\'"|~`]\w*')
        if (p.match(dir) != None) or (p.match(file_name) != None):
            return "internal error - unauthourized access"
        return serveFile(self.data_dir+"/"+dir+"/"+file_name, "application/x-download", "attachment")
 
    getSqliteFile.exposed = True

    def getFileInfo(self,file_name, port, dir, pswd):
        if pswd != 'adminminda':
            return "Error, no authorization"
        url = "http://"+cherrypy.request.headers['Remote-Addr']+":"+port+"/DataDistribution/serveSqliteFile?"
        par = "file_name="+file_name
        #print url
        try:
            dataHandle = urllib.urlopen(url+par)
        except:
            return "Error, application server couldn't connect to web serwer. Contact page administrator"
        
        fn = re.sub("[0-9]+_(.*)","\\1",file_name)
        #print fn 
        path = self.data_dir+"/"+dir+"/"+fn
        #print path
        if os.path.exists(path):
            return "Error, file with that name already exist"
        f = open(path, 'wb')
        while 1:
            data = dataHandle.read(1024 * 8) # Read blocks of 8KB at a time
            if not data: break
            f.write(data)
        f.close()
        return "True"
        
    getFileInfo.exposed = True
